/**
 * Unwrap the input and assert the value using the specified asserter.
 *
 * The asserter should throw an error if the assertion fails,
 * and return the value (or a transformed value, for convenient) otherwise.
 *
 * @param input The input promise
 * @param asserter The assertion function.
 */
export async function asyncAssert(input, asserter) {
    const r = await input;
    return await asserter(r) ?? r;
}
//# sourceMappingURL=async_assert.js.map